
;  MACRO.INC -- Generic set of macros and equates.

;;.model  small

.xlist                                    ;Turn off list-file generation.

bptr         equ   byte ptr
wptr         equ   word ptr
dptr         equ   dword ptr
fptr         equ   far ptr
nptr         equ   near ptr

.sall                                     ;Don't show macro contents.

extb         macro   a,b,c,d,e,f,g,h,i,j,k
             irp     xx,<a,b,c,d,e,f,g,h,i,j,k>
             ifnb    <xx>
             extrn   xx:byte
             else
             exitm
             endif
             endm
             endm

extw         macro   a,b,c,d,e,f,g,h,i,j,k
             irp     xx,<a,b,c,d,e,f,g,h,i,j,k>
             ifnb    <xx>
             extrn   xx:word
             else
             exitm
             endif
             endm
             endm

extd         macro   a,b,c,d,e,f,g,h,i,j,k
             irp     xx,<a,b,c,d,e,f,g,h,i,j,k>
             ifnb    <xx>
             extrn   xx:dword
             else
             exitm
             endif
             endm
             endm

extn         macro   a,b,c,d,e,f,g,h,i,j,k
             irp     xx,<a,b,c,d,e,f,g,h,i,j,k>
             ifnb    <xx>
             extrn   xx:near
             else
             exitm
             endif
             endm
             endm

extf         macro   a,b,c,d,e,f,g,h,i,j,k
             irp     xx,<a,b,c,d,e,f,g,h,i,j,k>
             ifnb    <xx>
             extrn   xx:far
             else
             exitm
             endif
             endm
             endm

extp         macro   a,b,c,d,e,f,g,h,i,j,k
             irp     xx,<a,b,c,d,e,f,g,h,i,j,k>
             ifnb    <xx>
             extrn   xx:proc
             else
             exitm
             endif
             endm
             endm

pushr        macro   a,b,c,d,e,f,g,h,i,j,k
             irp     xx,<a,b,c,d,e,f,g,h,i,j,k>
             ifnb    <xx>
             push    xx
             else
             exitm
             endif
             endm
             endm

popr         macro   a,b,c,d,e,f,g,h,i,j,k
             irp     xx,<a,b,c,d,e,f,g,h,i,j,k>
             ifnb    <xx>
             pop     xx
             else
             exitm
             endif
             endm
             endm

pushad       macro
             push  ax
             push  bx
             push  cx
             push  dx
             endm

popad        macro
             pop   dx
             pop   cx
             pop   bx
             pop   ax
             endm

pushall      macro
             push  ax
             push  bx
             push  cx
             push  dx
             push  di
             push  si
             push  ds
             push  es
             endm

popall       macro
             pop   es
             pop   ds
             pop   si
             pop   di
             pop   dx
             pop   cx
             pop   bx
             pop   ax
             endm

jmps         macro  n
             jmp   short n
             endm

dso          macro  n
             dw    offset n
             dw    seg n
             endm

shrr         macro  reg,count
             rept  count
             shr   reg,1
             endm
             endm

shlr         macro  reg,count
             rept  count
             shl   reg,1
             endm
             endm

; Factor      =   1    2    3     4     5     6      7       8
; -------------------------------------------------------------------
; Power of 2  =   2    4    8    16    32    64     128     256

shmul        macro  factor         ;;On entry DX:AX = value to multiply.
             rept  factor          ;;FACTOR = a power of 2.
             shl   ax,1            ;;Example: DX:AX * 8 = shmul 3
             rcl   dx,1
             endm
             endm

shdiv        macro  factor         ;;On entry DX:AX = value to divide.
             rept  factor          ;;FACTOR = a power of 2.
             shr   dx,1            ;;Example: DX:AX / 8 = shdiv 3
             rcr   ax,1
             endm
             endm

;--------------------------------------------------------------------;
;  The below allows the use of the SHL instruction to multiply a     ;
;  16-bit value by a quotient that is not a power of 2. In all       ;
;  cases: REG1 is the primary register that holds the value to be    ;
;  multiplied and that returns the sum. REG2 is the general work     ;
;  register. SH?? is the macro name and ?? is the "multiply by" value.;
;--------------------------------------------------------------------;

sh3          macro  reg1,reg2
             mov   reg2,reg1       ;;Place copy of value in REG2.
             shl   reg1,1          ;;Multiply REG1 by 2.
             add   reg1,reg2       ;;REG1 = REG1 + REG2
             endm

sh6          macro  reg1,reg2
             mov   reg2,reg1       ;;Place copy of value in REG2.
             shl   reg1,1          ;;Multiply REG1 by 4.
             shl   reg1,1
             shl   reg2,1          ;;Multiply REG2 by 2.
             add   reg1,reg2       ;;REG1 = REG1 + REG2
             endm

sh10         macro  reg1,reg2
             mov   reg2,reg1       ;;Place copy of value in REG2.
             shl   reg1,1          ;;Multiply REG1 by 8.
             shl   reg1,1
             shl   reg1,1
             shl   reg2,1          ;;Multiply REG2 by 2.
             add   reg1,reg2       ;;REG1 = REG1 + REG2
             endm

sh12         macro  reg1,reg2
             mov   reg2,reg1       ;;Place copy of value in REG2.
             shl   reg1,1          ;;Multiply REG1 by 8.
             shl   reg1,1
             shl   reg1,1
             shl   reg2,1          ;;Multiply REG2 by 4.
             shl   reg2,1
             add   reg1,reg2       ;;REG1 = REG1 + REG2
             endm

sh20         macro  reg1,reg2
             mov   reg2,reg1       ;;Place copy of value in REG2.
             shl   reg1,1          ;;Multiply REG1 by 16.
             shl   reg1,1
             shl   reg1,1
             shl   reg1,1
             shl   reg2,1          ;;Multiply REG2 by 4.
             shl   reg2,1
             add   reg1,reg2       ;;REG1 = REG1 + REG2
             endm

sh24         macro  reg1,reg2
             mov   reg2,reg1       ;;Place copy of value in REG2.
             shl   reg1,1          ;;Multiply REG1 by 16.
             shl   reg1,1
             shl   reg1,1
             shl   reg1,1
             shl   reg2,1          ;;Multiply REG2 by 8.
             shl   reg2,1
             shl   reg2,1
             add   reg1,reg2       ;;REG1 = REG1 + REG2
             endm

sh36         macro  reg1,reg2
             mov   reg2,reg1       ;;Place copy of value in REG2.
             shl   reg1,1          ;;Multiply REG1 by 32.
             shl   reg1,1
             shl   reg1,1
             shl   reg1,1
             shl   reg1,1
             shl   reg2,1          ;;Multiply REG2 by 4.
             shl   reg2,1
             add   reg1,reg2       ;;REG1 = REG1 + REG2
             endm

sh48         macro  reg1,reg2
             mov   reg2,reg1       ;;Place copy of value in REG2.
             shl   reg1,1          ;;Multiply REG1 by 32.
             shl   reg1,1
             shl   reg1,1
             shl   reg1,1
             shl   reg1,1
             shl   reg2,1          ;;Multiply REG2 by 16.
             shl   reg2,1
             shl   reg2,1
             shl   reg2,1
             add   reg1,reg2       ;;REG1 = REG1 + REG2
             endm

.list                                     ;End of MACRO.INC
